//+------------------------------------------------------------------+
//|                                        Trend Detection Index.mq4 |
//|                                                           mladen |
//|                                                                  |
//| Trend Detection Index originaly developed by M.H. Pee            |
//| TASC : 19:10 (October 2001) article                              |
//| "Are You In A Trend? Trend Detection Index"                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     Red
#property indicator_color2     DeepSkyBlue
#property indicator_color3     PaleVioletRed
#property indicator_color4     PaleVioletRed
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_level1     0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int    Length          = 20;
extern int    Price           = PRICE_CLOSE;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double Td[];
double Tdi[];
double TdiDa[];
double TdiDb[];
double trend[];
double values[][4];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,Td);    SetIndexLabel(0,"TD");
   SetIndexBuffer(1,Tdi);   SetIndexLabel(1,"TDI");
   SetIndexBuffer(2,TdiDa); SetIndexLabel(2,"TDI");
   SetIndexBuffer(3,TdiDb); SetIndexLabel(3,"TDI");
   SetIndexBuffer(4,trend);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define mom      0
#define abs      1
#define sum_abs  2
#define sum_abs2 3

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,j,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-Length*2);
         if (ArrayRange(values,0) != Bars) ArrayResize(values,Bars);
         if (trend[limit]==-1) CleanPoint(limit,TdiDa,TdiDb);

   //
   //
   //
   //
   //

   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      values[r][mom]      = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+Length);
      values[r][abs]      = MathAbs(values[r][mom]);
      values[r][sum_abs]  = 0;
      values[r][sum_abs2] = 0;
      Td[i]               = 0;

      //
      //
      //
      //
      //

         for (j=0;j<Length;j++)
         {
            Td[i]               += values[r-j][mom];
            values[r][sum_abs]  += values[r-j][abs];
            values[r][sum_abs2] += values[r-j][abs];
         }                  
         for (;j<Length*2;j++) values[r][sum_abs2] += values[r-j][abs];

      //
      //
      //
      //
      //
      
      Tdi[i]   = MathAbs(Td[i])+values[r][sum_abs]-values[r][sum_abs2];
      TdiDa[i] = EMPTY_VALUE;
      TdiDb[i] = EMPTY_VALUE;
      trend[i] = trend[i+1];
      if (Tdi[i]>Tdi[i+1]) trend[i] = 1;
      if (Tdi[i]<Tdi[i+1]) trend[i] =-1;
      if (trend[i]==-1) PlotPoint(i,TdiDa,TdiDb,Tdi);      
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Trend Detection Index ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Trend Detection Index " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Trend Detection Index "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

